﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using navigation.Data;
using System.Collections.ObjectModel;

namespace navigation.Controls
{
    /// <summary>
    /// Interaction logic for FlipStoryCard.xaml
    /// </summary>
    public partial class FlipStoryCard : UserControl
    {
        public FlipStoryCard()
        {
            InitializeComponent();
        }

        private static DependencyProperty StoryNameProperty = DependencyProperty.Register("StoryName", typeof(string), typeof(FlipStoryCard));

        private static DependencyProperty StoryContentProperty = DependencyProperty.Register("StoryContent", typeof(string), typeof(FlipStoryCard));

        private static DependencyProperty StoryPointsProperty = DependencyProperty.Register("StoryPoints", typeof(int), typeof(FlipStoryCard));

        private static DependencyProperty TaskListProperty = DependencyProperty.Register("TaskList", typeof(ObservableCollection<Task>), typeof(FlipStoryCard)); 

        public string StoryName
        {
            get
            {
                return (string)GetValue(FlipStoryCard.StoryNameProperty);
            }
            set
            {
                SetValue(FlipStoryCard.StoryNameProperty, value);
            }
        }

        public string StoryContent
        {
            get
            {
                return (string)GetValue(FlipStoryCard.StoryContentProperty);
            }
            set
            {
                SetValue(FlipStoryCard.StoryContentProperty, value);
            }
        }

        public int StoryPoints
        {
            get
            {
                return (int)GetValue(FlipStoryCard.StoryPointsProperty);
            }
            set
            {
                SetValue(FlipStoryCard.StoryPointsProperty, value);
            }
        }

        public ObservableCollection<Task> TaskList
        {
            get
            {
                return (ObservableCollection<Task>)GetValue(FlipStoryCard.TaskListProperty);
            }
            set
            {
                SetValue(FlipStoryCard.TaskListProperty, value);
            }
        }
    }
}
